package cn.tonyandmoney.tuon.core.request;

import cn.tonyandmoney.tuon.core.user.IUser;
import org.springframework.web.server.ServerWebExchange;

/**
 * @Classname ReqUtils
 * @Description TODO
 * @Date 2019/9/10 9:43
 * @Created By Administrator
 */
public class ReqUtils {

    public final static String KEY_USER = "Req_User";
    public final static String KEY_USER_ID = "Req_User_ID";


    /**
     * 获取用户信息
     *
     * @param exchange 请求
     * @return
     */
    public static IUser getUser(ServerWebExchange exchange) {
        return exchange.getAttribute(KEY_USER);
    }

    /**
     * 获取用户ID
     *
     * @param exchange 请求
     * @return
     */
    public static String getUserId(ServerWebExchange exchange) {
        return exchange.getAttribute(KEY_USER_ID);
    }

    /**
     * 设置用户信息
     *
     * @param exchange 请求
     * @param user
     * @param <T>      用户的实现类
     * @return
     */
    public static <T extends IUser> T setUser(ServerWebExchange exchange, T user) {
        exchange.getAttributes().put(KEY_USER, user);
        exchange.getAttributes().put(KEY_USER_ID, user.getUserId());
        return user;
    }

}
