package cn.tonyandmoney.tuon.core.user;

import java.util.Collections;
import java.util.List;
import java.util.Set;

/**
 * @Classname IUser
 * @Description TODO
 * @Date 2019/8/25 19:55
 * @Created by Administrator
 */
public interface IUser {

    /**
     * 获取用户的ID
     *
     * @return
     */
    String getUserId();

    /**
     * 用户的姓名，并不是别的
     *
     * @return
     */
    String getUsername();

    /**
     * 用户的账号
     *
     * @return
     */
    String getAccount();


    /**
     * 是否为用户，返回true标识用户，反之则为客户端
     *
     * @return
     */
    default boolean isClient() {
        return false;
    }

    /**
     * 获取授权的用户信息
     * @return
     */
    default IUser getUser(){
        return this;
    }

    default void setUser(IUser user){

    }

    default Set<String> getRoleIdList() {
        return Collections.emptySet();
    }

    default Set<String> getGroupIdList() {
        return Collections.emptySet();
    }

    default Set<String> getDeptIdList() {
        return Collections.emptySet();
    }

    default List<IDept> getDepts() {
        return Collections.emptyList();
    }

    default List<IRole> getRoles() {
        return Collections.emptyList();
    }

    default Set<String> getTagList() {
        return Collections.emptySet();
    }

    default List<IUserGroup> getUserGroup() {
        return Collections.emptyList();
    }

}
