package cn.tonyandmoney.tuon.core.utils;

import cn.tonyandmoney.tuon.core.TuonCoreKt;
import org.springframework.lang.Nullable;

import java.util.*;

import static org.springframework.util.StringUtils.deleteAny;

/**
 * 工具类
 */
public class CoreUtils {


    public static Set<String> delimitedList(String str) {
        return delimitedList(str, TuonCoreKt.DELIMITER);
    }

    public static Set<String> delimitedList(@Nullable String str, @Nullable String delimiter) {
        return delimitedList(str, delimiter, null);
    }

    /**
     * 将字符串转换成数组
     *
     * @param str           原始数据
     * @param delimiter     分隔符
     * @param charsToDelete
     * @return
     */
    public static Set<String> delimitedList(@Nullable String str, @Nullable String delimiter, @Nullable String charsToDelete) {
        if (str == null) {
            return Collections.emptySet();
        }
        if (delimiter == null) {
            return Collections.emptySet();
        }

        Set<String> result = new HashSet<>();
        if (delimiter.isEmpty()) {
            for (int i = 0; i < str.length(); i++) {
                result.add(deleteAny(str.substring(i, i + 1), charsToDelete));
            }
        } else {
            int pos = 0;
            int delPos;
            while ((delPos = str.indexOf(delimiter, pos)) != -1) {
                result.add(deleteAny(str.substring(pos, delPos), charsToDelete));
                pos = delPos + delimiter.length();
            }
            if (str.length() > 0 && pos <= str.length()) {
                // Add rest of String, but not in case of empty input.
                result.add(deleteAny(str.substring(pos), charsToDelete));
            }
        }
        return result;
    }
}
